//
// MPEG1 Audio Layer-3 Class
// Copyright(C) 2000 by TOx2RO / O2 Software All rights reserved.
//
// MP3Play.cpp
//

#include "MP3Play.h"

//
// RXgN^
//
MP3Play::MP3Play()
{
	// ϐ̏
	Bitrate			= 0;
	Channel			= 0;
	Buffer[0]		= NULL;
	Buffer[1]		= NULL;
	BufferingNumber = MaxBufferingNumber;
	sw				= 0;
	State			= Closed;
	LoopCount		= 0;
	LoopMode		= 0;
	FileHandle		= NULL;
	FileName		= NULL;
	FileSize		= 0;
	MapFile			= NULL;
	pSrcFile		= NULL;
	pFrameData		= NULL;
	FrameSize		= 0;
	Frequency		= 0;
	NowPos			= 0;
	WaveOut			= NULL;
	PartitionNumber	= 0;
	Partition		= 0;
	startSec		= 0;
	endSec			= 0;
	loopSec			= 0;
	ThreadHandle	= NULL;
	ThreadID		= 0;
	NowLooping		= false;
	InfiniteLoop	= false;
	ZeroMemory(&PCMwf,sizeof(WAVEFORMATEX));
	ZeroMemory(&PCMwh[0],sizeof(WAVEHDR));
	ZeroMemory(&PCMwh[1],sizeof(WAVEHDR));
	ZeroMemory(&MP3DI,sizeof(MPEG_DECODE_INFO));
	ZeroMemory(&MP3DP[0],sizeof(MPEG_DECODE_PARAM));
	ZeroMemory(&MP3DP[1],sizeof(MPEG_DECODE_PARAM));
}

//
// fXgN^
//
MP3Play::~MP3Play()
{
	// t@CĂȂΕ
	if(State != Closed) { Close(); }
}

//
// loRt@CJ
//
LRESULT	MP3Play::Open(LPSTR mp3file)
{
	// t@CɊJĂΉȂ
	if(State != Closed) { return NoError; }

	// t@CJ
	FileHandle	= CreateFile(mp3file,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,
							FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS,NULL);
	MapFile		= CreateFileMapping(FileHandle,NULL,PAGE_READONLY,0,0,NULL);
	pSrcFile	= (BYTE*)MapViewOfFile(MapFile,FILE_MAP_READ,0,0,0);

	if(FileHandle == INVALID_HANDLE_VALUE) { return NoFile; }
	if(!MapFile) { return NoFile; }
	if(!pSrcFile) { return NoFile; }

	//
	// MPEG1 Audio Layer-3 `ł邩`FbN
	//

	// RIFF `NĂ邩
	if(!memcmp(&pSrcFile[0],"RIFF",4))
	{
		// RIFF WAVE `
		if(!memcmp(&pSrcFile[8],"WAVEfmt",7))
		{
			if(!memcmp(&pSrcFile[50],"fact",4)) { pFrameData = pSrcFile + 70; }
			if(!memcmp(&pSrcFile[52],"fact",4)) { pFrameData = pSrcFile + 72; }
			if(!memcmp(&pSrcFile[50],"data",4)) { pFrameData = pSrcFile + 58; }
		}
		// RIFF MP3 `
		if(!memcmp(&pSrcFile[8],"RMP3",4))
		{
			if(!memcmp(&pSrcFile[12],"data",4)) { pFrameData = pSrcFile + 16; }
		}
	} else {
		pFrameData = pSrcFile;
	}
	
	// t@CTCYZo(wb_EhcR^OO)
	FileSize = GetFileSize(FileHandle,NULL);
	FileSize -= (DWORD)(pFrameData - pSrcFile);
	if((pSrcFile[FileSize - 128] == 'T') && (pSrcFile[FileSize - 127] == 'A') && (pSrcFile[FileSize - 126] == 'G'))
	{
		FileSize -= 128;
	}

	int	aBitrate[2][16] = {
		{ 0,32,40,48,56,64,80,96,112,128,160,192,224,256,320,0 },
		{ 0, 8,16,24,32,64,80,56, 64,128,160,112,128,256,320,0 }
	};

	int aFrequency[2][4] = {
		{ 44100,48000,32000,0 },
		{ 22050,24000,16000,0 }
	};

	MpegSpec	= ((pFrameData[1] & 8) == 0) ? 1 : 0;
	Bitrate		= aBitrate[ MpegSpec ][ pFrameData[2] >> 4 ];
	Frequency	= aFrequency[ MpegSpec ][ (pFrameData[2] >> 2) & 3 ];
	Channel		= (pFrameData[3] >> 6 == 3) ? 1 : 2;
	FrameSize	= 144000 * Bitrate / Frequency;

	//
	// PCM ϊWAVEFORMAT\̂
	//
	PCMwf.wFormatTag			= WAVE_FORMAT_PCM;
	PCMwf.nChannels				= Channel;
	PCMwf.nSamplesPerSec		= Frequency;
	PCMwf.nAvgBytesPerSec		= Frequency * Channel * 2;
	PCMwf.nBlockAlign			= Channel * 2;
	PCMwf.wBitsPerSample		= 16;

	// loRfR[_
	mp3DecodeInit();
	mp3GetDecodeInfo(pFrameData,FrameSize,&MP3DI,1);
	mp3DecodeStart(pFrameData,FileSize);

	// f[^obt@̊m
	Buffer[0] = GlobalAlloc(GPTR,MP3DI.outputSize * MaxBufferingNumber);
	Buffer[1] = GlobalAlloc(GPTR,MP3DI.outputSize * MaxBufferingNumber);
	if(!Buffer[0]) { return NoMemory; }
	if(!Buffer[1]) { return NoMemory; }

	//
	// EF[ufoCXJ
	//
	waveOutOpen( &WaveOut, WAVE_MAPPER, &PCMwf, (DWORD)waveOutProc, (DWORD)this, CALLBACK_FUNCTION );

	State = Opened;

return NoError;
}

//
// loRt@C
//
LRESULT MP3Play::Close()
{
	// t@CɕĂΉȂ
	if(State == Closed) { return NoError; }

	// Đ(ꎞ~)Ȃ~
	if(State == Playing || State == Paused) { Stop(); }

	// EF[ufoCX
	waveOutClose(WaveOut);

	// f[^obt@̉
	if(Buffer[0]) { GlobalFree(Buffer[0]); }
	if(Buffer[1]) { GlobalFree(Buffer[1]); }

	//t@C
	UnmapViewOfFile(pSrcFile);
	CloseHandle(MapFile);
	CloseHandle(FileHandle);

	// ϐ̃NA
	Bitrate			= 0;
	Channel			= 0;
	Buffer[0]		= NULL;
	Buffer[1]		= NULL;
	BufferingNumber = MaxBufferingNumber;
	sw				= 0;
	State			= Closed;
	LoopCount		= 0;
	LoopMode		= 0;
	FileHandle		= NULL;
	FileName		= NULL;
	FileSize		= 0;
	MapFile			= NULL;
	pSrcFile		= NULL;
	pFrameData		= NULL;
	FrameSize		= 0;
	Frequency		= 0;
	NowPos			= 0;
	WaveOut			= NULL;
	PartitionNumber	= 0;
	Partition		= 0;
	startSec		= 0;
	endSec			= 0;
	loopSec			= 0;
	ThreadHandle	= NULL;
	ThreadID		= 0;
	NowLooping		= false;
	InfiniteLoop	= false;
	ZeroMemory(&PCMwf,sizeof(WAVEFORMATEX));
	ZeroMemory(&PCMwh[0],sizeof(WAVEHDR));
	ZeroMemory(&PCMwh[1],sizeof(WAVEHDR));
	ZeroMemory(&MP3DI,sizeof(MPEG_DECODE_INFO));
	ZeroMemory(&MP3DP[0],sizeof(MPEG_DECODE_PARAM));
	ZeroMemory(&MP3DP[1],sizeof(MPEG_DECODE_PARAM));

	State = Closed;
	
	return NoError;	
}

//
// Đ
//
LRESULT MP3Play::Play(DWORD start,DWORD end)
{
	// ɍĐĂꍇ͉Ȃ
	if(State != Opened) { return NoError; }

	//ϐ̃NA
	sw = 0;
	Partition = 0;
	startSec = start;
	endSec = end;
	LoopMode = 0;

	State = Playing;

	// ĐʒuEIʒu`FbN
	if(startSec > endSec) { startSec = 0; endSec = (FileSize / Bitrate * 8); }
	if(startSec < 0) { startSec = 0; }
	if(startSec == 0 && endSec == 0 ) { startSec = 0; endSec = ((FileSize / FrameSize) * FrameSize / Bitrate * 8); }
	if((FileSize / Bitrate * 8) < startSec) { startSec = 0; }
	if((FileSize / Bitrate * 8) < endSec) { endSec = (FileSize / Bitrate * 8); }

	// obt@Ot[vZ
	BufferingNumber = MaxBufferingNumber;
	if(BufferingNumber > (msec2frame(endSec) - msec2frame(startSec)) + 1) { BufferingNumber = msec2frame(endSec) - msec2frame(startSec) + 1; }

	// Đ镔̕vZ
	PartitionNumber = (((msec2frame(endSec) - msec2frame(startSec)) + 1) / BufferingNumber);
	if(((msec2frame(endSec) - msec2frame(startSec)) + 1) % BufferingNumber == 0) { PartitionNumber--; }

	// Đʒu܂܂t[oblɕϊ
	ZeroMemory(&MP3DP[sw],sizeof(MPEG_DECODE_PARAM));

	WORD i = 0;

	// ĐʒuÔXt[fR[hĂ
	if(msec2frame(startSec) <= 9)
	{
		for(i = 0 ; i < msec2frame(startSec); i++)
		{
			mp3GetDecodeInfo(pFrameData + NowPos,FrameSize,&MP3DI,1);
			MP3DP[sw].header			=	MP3DI.header;
			MP3DP[sw].bitRate			=	MP3DI.bitRate;
			MP3DP[sw].inputBuf			=	pFrameData + NowPos;
			MP3DP[sw].inputSize			=	MP3DI.header.padding ? MP3DI.maxInputSize : MP3DI.minInputSize;
			MP3DP[sw].outputBuf			=	(BYTE*)Buffer[sw] + (MP3DI.outputSize * i);
			MP3DP[sw].outputSize		=	MP3DI.outputSize;	
			mp3DecodeFrame(&MP3DP[sw]);

			NowPos += MP3DI.header.padding ? MP3DI.maxInputSize : MP3DI.minInputSize;
		}
	}
	else if(msec2frame(startSec) > 9)
	{
		for(i = 0 ; i < msec2frame(startSec) - 9;i++)
		{
			mp3GetDecodeInfo(pFrameData + NowPos,FrameSize,&MP3DI,1);
			NowPos += MP3DI.header.padding ? MP3DI.maxInputSize : MP3DI.minInputSize;
		}

		for(i = 0 ; i < 9; i++)
		{
			
			mp3GetDecodeInfo(pFrameData + NowPos,FrameSize,&MP3DI,1);
			MP3DP[sw].header			=	MP3DI.header;
			MP3DP[sw].bitRate			=	MP3DI.bitRate;
			MP3DP[sw].inputBuf			=	pFrameData + NowPos;
			MP3DP[sw].inputSize			=	MP3DI.header.padding ? MP3DI.maxInputSize : MP3DI.minInputSize;
			MP3DP[sw].outputBuf			=	(BYTE*)Buffer[sw] + (MP3DI.outputSize * i);
			MP3DP[sw].outputSize		=	MP3DI.outputSize;	
			mp3DecodeFrame(&MP3DP[sw]);
			
			NowPos += MP3DI.header.padding ? MP3DI.maxInputSize : MP3DI.minInputSize;
		}
	}

	// loRfR[hĐ

	for(i = 0 ; i < BufferingNumber ; i++)
	{
	mp3GetDecodeInfo(pFrameData + NowPos,FrameSize,&MP3DI,1);
	MP3DP[sw].header			=	MP3DI.header;
	MP3DP[sw].bitRate			=	MP3DI.bitRate;
	MP3DP[sw].inputBuf			=	pFrameData + NowPos;
	MP3DP[sw].inputSize			=	MP3DI.header.padding ? MP3DI.maxInputSize : MP3DI.minInputSize;
	MP3DP[sw].outputBuf			=	(BYTE*)Buffer[sw] + (MP3DI.outputSize * i);
	MP3DP[sw].outputSize		=	MP3DI.outputSize;
	mp3DecodeFrame(&MP3DP[sw]);

	NowPos += MP3DI.header.padding ? MP3DI.maxInputSize : MP3DI.minInputSize;
	}

	// oblɕϊꂽf[^Đ
	// (ۂɍĐ̂ startSec Ŏw肳ꂽʒu)
	ZeroMemory(&PCMwh[sw],sizeof(WAVEHDR));
	PCMwh[sw].lpData			= (char*)Buffer[sw] + (msec2bytes(startSec) - (msec2frame(startSec) * MP3DI.outputSize));
	PCMwh[sw].dwBufferLength	= MP3DI.outputSize * BufferingNumber - (msec2bytes(startSec) - (msec2frame(startSec) * MP3DI.outputSize));

	waveOutPrepareHeader( WaveOut, &PCMwh[sw], sizeof(WAVEHDR));
	waveOutWrite( WaveOut, &PCMwh[sw], sizeof(WAVEHDR));

	// Xbh̍쐬
	ThreadHandle = CreateThread(NULL,0,DecodeFunc,(LPVOID)this,0,&ThreadID);

	return NoError;
}

//
// [vĐ
//
LRESULT MP3Play::LoopPlay(DWORD start,DWORD end,DWORD loop,DWORD number)
{
	// ɍĐĂꍇ͉Ȃ
	if(State != Opened) { return NoError; }

	//ϐ̃NA
	sw = 0;
	Partition = 0;
	startSec = start;
	endSec = end;
	loopSec = loop;
	NowLooping = false;
	LoopCount = number;
	LoopMode = 1;
	if (number == 0) { InfiniteLoop = true; }
	
	State = Playing;

	// ĐʒuEIʒuE[vʒu`FbN
	if(startSec > endSec) { startSec = 0; endSec = (FileSize / Bitrate * 8); }
	if(startSec < 0) { startSec = 0; }
	if(loopSec < 0) { loopSec = 0; }
	if(startSec == 0 && endSec == 0 && loopSec == 0) { startSec = 0; endSec = (FileSize / Bitrate * 8); loopSec = 0; }
	if((FileSize / Bitrate * 8) < startSec) { startSec = 0; }
	if((FileSize / Bitrate * 8) < endSec) { endSec = (FileSize / Bitrate * 8); }
	if(loopSec > endSec) { loopSec = 0; }

	// obt@Ot[vZ
	BufferingNumber = MaxBufferingNumber;
	if(BufferingNumber > (msec2frame(endSec) - msec2frame(startSec)) + 1) { BufferingNumber = msec2frame(endSec) - msec2frame(startSec) + 1; }

	// Đ镔̕vZ
	PartitionNumber = (((msec2frame(endSec) - msec2frame(startSec)) + 1) / BufferingNumber);
	if(((msec2frame(endSec) - msec2frame(startSec)) + 1) % BufferingNumber == 0) { PartitionNumber--; }

	// Đʒu܂܂t[oblɕϊ
	ZeroMemory(&MP3DP[sw],sizeof(MPEG_DECODE_PARAM));

	WORD i = 0;

	// ĐʒuÔXt[fR[hĂ
	if(msec2frame(startSec) <= 9)
	{
		for(i = 0 ; i < msec2frame(startSec); i++)
		{
			mp3GetDecodeInfo(pFrameData + NowPos,FrameSize,&MP3DI,1);
			MP3DP[sw].header			=	MP3DI.header;
			MP3DP[sw].bitRate			=	MP3DI.bitRate;
			MP3DP[sw].inputBuf			=	pFrameData + NowPos;
			MP3DP[sw].inputSize			=	MP3DI.header.padding ? MP3DI.maxInputSize : MP3DI.minInputSize;
			MP3DP[sw].outputBuf			=	(BYTE*)Buffer[sw] + (MP3DI.outputSize * i);
			MP3DP[sw].outputSize		=	MP3DI.outputSize;	
			mp3DecodeFrame(&MP3DP[sw]);

			NowPos += MP3DI.header.padding ? MP3DI.maxInputSize : MP3DI.minInputSize;
		}
	}
	else if(msec2frame(startSec) > 9)
	{
		for(i = 0 ; i < msec2frame(startSec) - 9;i++)
		{
			mp3GetDecodeInfo(pFrameData + NowPos,FrameSize,&MP3DI,1);
			NowPos += MP3DI.header.padding ? MP3DI.maxInputSize : MP3DI.minInputSize;
		}

		for(i = 0 ; i < 9; i++)
		{
			mp3GetDecodeInfo(pFrameData + NowPos,FrameSize,&MP3DI,1);
			MP3DP[sw].header			=	MP3DI.header;
			MP3DP[sw].bitRate			=	MP3DI.bitRate;
			MP3DP[sw].inputBuf			=	pFrameData + NowPos;
			MP3DP[sw].inputSize			=	MP3DI.header.padding ? MP3DI.maxInputSize : MP3DI.minInputSize;
			MP3DP[sw].outputBuf			=	(BYTE*)Buffer[sw] + (MP3DI.outputSize * i);
			MP3DP[sw].outputSize		=	MP3DI.outputSize;	
			mp3DecodeFrame(&MP3DP[sw]);
			
			NowPos += MP3DI.header.padding ? MP3DI.maxInputSize : MP3DI.minInputSize;
		}
	}

	// loRfR[hĐ
	for(i = 0 ; i < BufferingNumber ; i++)
	{
	mp3GetDecodeInfo(pFrameData + NowPos,FrameSize,&MP3DI,1);
	MP3DP[sw].header			=	MP3DI.header;
	MP3DP[sw].bitRate			=	MP3DI.bitRate;
	MP3DP[sw].inputBuf			=	pFrameData + NowPos;
	MP3DP[sw].inputSize			=	MP3DI.header.padding ? MP3DI.maxInputSize : MP3DI.minInputSize;
	MP3DP[sw].outputBuf			=	(BYTE*)Buffer[sw] + (MP3DI.outputSize * i);
	MP3DP[sw].outputSize		=	MP3DI.outputSize;
	mp3DecodeFrame(&MP3DP[sw]);

	NowPos += MP3DI.header.padding ? MP3DI.maxInputSize : MP3DI.minInputSize;
	}

	// oblɕϊꂽf[^Đ
	// (ۂɍĐ̂ startSec Ŏw肳ꂽʒu)
	ZeroMemory(&PCMwh[sw],sizeof(WAVEHDR));
	PCMwh[sw].lpData			= (char*)Buffer[sw] + (msec2bytes(startSec) - (msec2frame(startSec) * MP3DI.outputSize));
	PCMwh[sw].dwBufferLength	= MP3DI.outputSize * BufferingNumber - (msec2bytes(startSec) - (msec2frame(startSec) * MP3DI.outputSize));

	waveOutPrepareHeader( WaveOut, &PCMwh[sw], sizeof(WAVEHDR));
	waveOutWrite( WaveOut, &PCMwh[sw], sizeof(WAVEHDR));

	// Xbh̍쐬
	ThreadHandle = CreateThread(NULL,0,DecodeFunc,(LPVOID)this,0,&ThreadID);

	return NoError;
}

//
// ꎞ~
//
LRESULT MP3Play::Pause()
{
	if(State != Playing) { return UnknownError; }
	waveOutPause(WaveOut);

	State = Paused;

	return NoError;
}

//
// ꎞ~
//
LRESULT MP3Play::Resume()
{
	if(State != Paused) { return UnknownError; }
	waveOutRestart(WaveOut);

	State = Playing;

	return NoError;
}

//
// ~
//
LRESULT MP3Play::Stop()
{
	// ɒ~Ăꍇ͉Ȃ
	if(State == Opened) { return NoError; }

	State = Opened;

	waveOutReset(WaveOut);
	waveOutUnprepareHeader(WaveOut, &PCMwh[0], sizeof(WAVEHDR));
	waveOutUnprepareHeader(WaveOut, &PCMwh[1], sizeof(WAVEHDR));

	return NoError;
}

//
// EF[uo̓R[obN֐
//
void CALLBACK MP3Play::waveOutProc(HWAVE hwo,UINT uMsg,DWORD dwInstance,DWORD dwParam1,DWORD dwParam2)
{
	// IuWFNg̃AhX擾
	MP3Play *pMP3 = (MP3Play*)dwInstance;

	if( uMsg == WOM_DONE && pMP3->State == Playing)
	{
		//WaitForSingleObject(pMP3->ThreadHandle,INFINITE);
		pMP3->ThreadHandle = CreateThread(NULL,0,pMP3->DecodeFunc,(LPVOID)dwInstance,0,&pMP3->ThreadID);
	}

	return NoError;
}

//
// loRfR[hXbh
//

void MP3Play::DecodeFunc(LPVOID dwInstance)
{
	WORD i = 0;

	// IuWFNg̃AhX擾
	MP3Play *pMP3 = (MP3Play*)dwInstance;

	// Ō̃f[^ubN̍Đ
	if(pMP3->Partition == pMP3->PartitionNumber - 1)
	{
		// ĐIf[^ubN̉
		if(pMP3->Partition != 0 || pMP3->NowLooping == true)
		{
			pMP3->sw ^= 1;
			waveOutUnprepareHeader( pMP3->WaveOut, &pMP3->PCMwh[pMP3->sw], sizeof(WAVEHDR) );
			pMP3->sw ^= 1;
		}

		// obt@XCb`
		pMP3->sw ^= 1;
		
		// Ō̃f[^ubN̏
		pMP3->Partition++;
		ZeroMemory(pMP3->Buffer[pMP3->sw],pMP3->MP3DI.outputSize * pMP3->BufferingNumber);

		for(i = 0 ; i < pMP3->msec2frame(pMP3->endSec) - pMP3->msec2frame(pMP3->startSec) - (pMP3->BufferingNumber * pMP3->Partition) + 1 ; i++)
		{
		mp3GetDecodeInfo(pMP3->pFrameData + pMP3->NowPos,pMP3->FrameSize,&pMP3->MP3DI,1);
		pMP3->MP3DP[pMP3->sw].header			=	pMP3->MP3DI.header;
		pMP3->MP3DP[pMP3->sw].bitRate			=	pMP3->MP3DI.bitRate;
		pMP3->MP3DP[pMP3->sw].inputBuf			=	pMP3->pFrameData + pMP3->NowPos;
		pMP3->MP3DP[pMP3->sw].inputSize			=	pMP3->MP3DI.header.padding ? pMP3->MP3DI.maxInputSize : pMP3->MP3DI.minInputSize;
		pMP3->MP3DP[pMP3->sw].outputBuf			=	(BYTE*)pMP3->Buffer[pMP3->sw] + (pMP3->MP3DI.outputSize * i);
		pMP3->MP3DP[pMP3->sw].outputSize		=	pMP3->MP3DI.outputSize;	
		mp3DecodeFrame(&pMP3->MP3DP[pMP3->sw]);

		pMP3->NowPos += pMP3->MP3DI.header.padding ? pMP3->MP3DI.maxInputSize : pMP3->MP3DI.minInputSize;
		}
		
		// oblɕϊꂽf[^Đ
		ZeroMemory(&pMP3->PCMwh[pMP3->sw],sizeof(WAVEHDR));
		pMP3->PCMwh[pMP3->sw].lpData			= (char*)pMP3->Buffer[pMP3->sw];
		pMP3->PCMwh[pMP3->sw].dwBufferLength	= pMP3->msec2bytes(pMP3->endSec) - pMP3->msec2bytes(pMP3->startSec) - pMP3->MP3DI.outputSize * (pMP3->BufferingNumber * pMP3->Partition);

		waveOutPrepareHeader( pMP3->WaveOut, &pMP3->PCMwh[pMP3->sw], sizeof(WAVEHDR));
		waveOutWrite( pMP3->WaveOut, &pMP3->PCMwh[pMP3->sw], sizeof(WAVEHDR));

		return NoError;
	}

	// ̃f[^ubN̍Đ
	if(pMP3->Partition < pMP3->PartitionNumber)
	{
		// ĐIf[^ubN̉
		if(pMP3->Partition != 0 || pMP3->NowLooping == true)
		{
			pMP3->sw ^= 1;
			waveOutUnprepareHeader( pMP3->WaveOut, &pMP3->PCMwh[pMP3->sw], sizeof(WAVEHDR) );
			pMP3->sw ^= 1;
		}
			
		// obt@XCb`
		pMP3->sw ^= 1;
			
		// ̃f[^ubN̏
		pMP3->Partition++;

		for(i = 0 ; i < pMP3->BufferingNumber ; i++)
		{
		mp3GetDecodeInfo(pMP3->pFrameData + pMP3->NowPos,pMP3->FrameSize,&pMP3->MP3DI,1);
		pMP3->MP3DP[pMP3->sw].header			=	pMP3->MP3DI.header;
		pMP3->MP3DP[pMP3->sw].bitRate			=	pMP3->MP3DI.bitRate;
		pMP3->MP3DP[pMP3->sw].inputBuf			=	pMP3->pFrameData + pMP3->NowPos;
		pMP3->MP3DP[pMP3->sw].inputSize			=	pMP3->MP3DI.header.padding ? pMP3->MP3DI.maxInputSize : pMP3->MP3DI.minInputSize;
		pMP3->MP3DP[pMP3->sw].outputBuf			=	(BYTE*)pMP3->Buffer[pMP3->sw] + (pMP3->MP3DI.outputSize * i);
		pMP3->MP3DP[pMP3->sw].outputSize		=	pMP3->MP3DI.outputSize;	
		mp3DecodeFrame(&pMP3->MP3DP[pMP3->sw]);

		pMP3->NowPos += pMP3->MP3DI.header.padding ? pMP3->MP3DI.maxInputSize : pMP3->MP3DI.minInputSize;
		}

		// oblɕϊꂽf[^Đ
		ZeroMemory(&pMP3->PCMwh[pMP3->sw],sizeof(WAVEHDR));
		pMP3->PCMwh[pMP3->sw].lpData			= (char*)pMP3->Buffer[pMP3->sw];
		pMP3->PCMwh[pMP3->sw].dwBufferLength	= pMP3->MP3DI.outputSize * pMP3->BufferingNumber;

		waveOutPrepareHeader( pMP3->WaveOut, &pMP3->PCMwh[pMP3->sw], sizeof(WAVEHDR));
		waveOutWrite( pMP3->WaveOut, &pMP3->PCMwh[pMP3->sw], sizeof(WAVEHDR));

		return NoError;
	}
	
	// ŌォPÕf[^ubN̉
	if(pMP3->Partition == pMP3->PartitionNumber)
	{
		// f[^ubN̉
		if(pMP3->Partition != 0 || pMP3->NowLooping == true)
		{
			pMP3->sw ^= 1;
			waveOutUnprepareHeader( pMP3->WaveOut, &pMP3->PCMwh[pMP3->sw], sizeof(WAVEHDR) );
			pMP3->sw ^= 1;
		}

		pMP3->Partition++;

		// [vĐ̏ꍇ̓f[^ubN̍ČvZ
		if(pMP3->LoopMode == 1)
		{
			// [vJEg
			if(pMP3->LoopCount == 0 && pMP3->InfiniteLoop == false) { _endthread(); return NoError; }

			pMP3->LoopCount--;

			// obt@XCb`
			pMP3->sw ^= 1;

			// obt@Ot[vZ
			pMP3->BufferingNumber = MaxBufferingNumber;
			if(pMP3->BufferingNumber > (pMP3->msec2frame(pMP3->endSec) - pMP3->msec2frame(pMP3->loopSec)) + 1) { pMP3->BufferingNumber = pMP3->msec2frame(pMP3->endSec) - pMP3->msec2frame(pMP3->loopSec) + 1; }

			// Đ镔̕vZ
			pMP3->PartitionNumber = (((pMP3->msec2frame(pMP3->endSec) - pMP3->msec2frame(pMP3->loopSec)) + 1) / pMP3->BufferingNumber);
			if(((pMP3->msec2frame(pMP3->endSec) - pMP3->msec2frame(pMP3->loopSec)) + 1) % pMP3->BufferingNumber == 0) { pMP3->PartitionNumber--; }

			// ϐ̃Zbg
			pMP3->Partition = 0;
			pMP3->NowPos = 0;

			// Đʒu܂܂t[oblɕϊ
			ZeroMemory(&pMP3->MP3DP[pMP3->sw],sizeof(MPEG_DECODE_PARAM));

			// ĐʒuÔXt[fR[hĂ
			if(pMP3->msec2frame(pMP3->loopSec) <= 9)
			{
				for(i = 0 ; i < pMP3->msec2frame(pMP3->loopSec); i++)
				{
					mp3GetDecodeInfo(pMP3->pFrameData + pMP3->NowPos,pMP3->FrameSize,&pMP3->MP3DI,1);
					pMP3->MP3DP[pMP3->sw].header			=	pMP3->MP3DI.header;
					pMP3->MP3DP[pMP3->sw].bitRate			=	pMP3->MP3DI.bitRate;
					pMP3->MP3DP[pMP3->sw].inputBuf			=	pMP3->pFrameData + pMP3->NowPos;
					pMP3->MP3DP[pMP3->sw].inputSize			=	pMP3->MP3DI.header.padding ? pMP3->MP3DI.maxInputSize : pMP3->MP3DI.minInputSize;
					pMP3->MP3DP[pMP3->sw].outputBuf			=	(BYTE*)pMP3->Buffer[pMP3->sw] + (pMP3->MP3DI.outputSize * i);
					pMP3->MP3DP[pMP3->sw].outputSize		=	pMP3->MP3DI.outputSize;	
					mp3DecodeFrame(&pMP3->MP3DP[pMP3->sw]);

					pMP3->NowPos += pMP3->MP3DI.header.padding ? pMP3->MP3DI.maxInputSize : pMP3->MP3DI.minInputSize;
				}
			}
			else if(pMP3->msec2frame(pMP3->loopSec) > 9)
			{
				for(i = 0 ; i < pMP3->msec2frame(pMP3->loopSec) - 9;i++)
				{
					mp3GetDecodeInfo(pMP3->pFrameData + pMP3->NowPos,pMP3->FrameSize,&pMP3->MP3DI,1);
					pMP3->NowPos += pMP3->MP3DI.header.padding ? pMP3->MP3DI.maxInputSize : pMP3->MP3DI.minInputSize;
				}

				for(i = 0 ; i < 9; i++)
				{
					mp3GetDecodeInfo(pMP3->pFrameData + pMP3->NowPos,pMP3->FrameSize,&pMP3->MP3DI,1);
					pMP3->MP3DP[pMP3->sw].header			=	pMP3->MP3DI.header;
					pMP3->MP3DP[pMP3->sw].bitRate			=	pMP3->MP3DI.bitRate;
					pMP3->MP3DP[pMP3->sw].inputBuf			=	pMP3->pFrameData + pMP3->NowPos;
					pMP3->MP3DP[pMP3->sw].inputSize			=	pMP3->MP3DI.header.padding ? pMP3->MP3DI.maxInputSize : pMP3->MP3DI.minInputSize;
					pMP3->MP3DP[pMP3->sw].outputBuf			=	(BYTE*)pMP3->Buffer[pMP3->sw] + (pMP3->MP3DI.outputSize * i);
					pMP3->MP3DP[pMP3->sw].outputSize		=	pMP3->MP3DI.outputSize;	
					mp3DecodeFrame(&pMP3->MP3DP[pMP3->sw]);

					pMP3->NowPos += pMP3->MP3DI.header.padding ? pMP3->MP3DI.maxInputSize : pMP3->MP3DI.minInputSize;
				}
			}

			// loRfR[hĐ
			for(i = 0 ; i < pMP3->BufferingNumber ; i++)
			{
			mp3GetDecodeInfo(pMP3->pFrameData + pMP3->NowPos,pMP3->FrameSize,&pMP3->MP3DI,1);
			pMP3->MP3DP[pMP3->sw].header			=	pMP3->MP3DI.header;
			pMP3->MP3DP[pMP3->sw].bitRate			=	pMP3->MP3DI.bitRate;
			pMP3->MP3DP[pMP3->sw].inputBuf			=	pMP3->pFrameData + pMP3->NowPos;
			pMP3->MP3DP[pMP3->sw].inputSize			=	pMP3->MP3DI.header.padding ? pMP3->MP3DI.maxInputSize : pMP3->MP3DI.minInputSize;
			pMP3->MP3DP[pMP3->sw].outputBuf			=	(BYTE*)pMP3->Buffer[pMP3->sw] + (pMP3->MP3DI.outputSize * i);
			pMP3->MP3DP[pMP3->sw].outputSize		=	pMP3->MP3DI.outputSize;
			mp3DecodeFrame(&pMP3->MP3DP[pMP3->sw]);

			pMP3->NowPos += pMP3->MP3DI.header.padding ? pMP3->MP3DI.maxInputSize : pMP3->MP3DI.minInputSize;
			}

			// oblɕϊꂽf[^Đ
			// (ۂɍĐ̂ loopSec Ŏw肳ꂽʒu)
			ZeroMemory(&pMP3->PCMwh[pMP3->sw],sizeof(WAVEHDR));
			pMP3->PCMwh[pMP3->sw].lpData			= (char*)pMP3->Buffer[pMP3->sw] + (pMP3->msec2bytes(pMP3->loopSec) - (pMP3->msec2frame(pMP3->loopSec) * pMP3->MP3DI.outputSize));
			pMP3->PCMwh[pMP3->sw].dwBufferLength	= pMP3->MP3DI.outputSize * pMP3->BufferingNumber - (pMP3->msec2bytes(pMP3->loopSec) - (pMP3->msec2frame(pMP3->loopSec) * pMP3->MP3DI.outputSize));

			waveOutPrepareHeader( pMP3->WaveOut, &pMP3->PCMwh[pMP3->sw], sizeof(WAVEHDR));
			waveOutWrite( pMP3->WaveOut, &pMP3->PCMwh[pMP3->sw], sizeof(WAVEHDR));
			
			pMP3->startSec = pMP3->loopSec;
			pMP3->NowLooping = true;

				return NoError;
		}

		return NoError;
	}
		
	// Ō̃f[^ubNĐ̓f[^ubN̉̂
	if(pMP3->Partition > pMP3->PartitionNumber)
	{
		// Ō̃f[^ubN̉
		waveOutUnprepareHeader( pMP3->WaveOut, &pMP3->PCMwh[pMP3->sw], sizeof(WAVEHDR) );
			
		pMP3->State = Opened;
		pMP3->LoopMode = 0;

		return NoError;
	}

	return NoError;
}

//
// CRCU[
//
LRESULT MP3Play::Equalize(EQ eq)
{
	int tEQ[10];

	// t@CJĂȂΉȂ
	if(State == Closed) { return NoError; }

	tEQ[0] = eq._60;
	tEQ[1] = eq._170;
	tEQ[2] = eq._310;
	tEQ[3] = eq._600;
	tEQ[4] = eq._1k;
	tEQ[5] = eq._3k;
	tEQ[6] = eq._6k;
	tEQ[7] = eq._12k;
	tEQ[8] = eq._14k;
	tEQ[9] = eq._16k;
	
	mp3SetEqualizer(&tEQ[0]);

	return NoError;
}

//
// ~bt[ɕϊ 
//
inline DWORD MP3Play::msec2frame(DWORD msec)
{
	float spf[] = {26.12245f, 24.0f, 36.0f};

	return (DWORD)(msec / spf[ (pFrameData[2] >> 2) & 3 ]);
}

//
// t[~bɕϊ 
//
inline DWORD MP3Play::frame2msec(DWORD frame)
{
	return frame * ((FrameSize / Bitrate) * 8);
}

//
// ~boCgɕϊ 
//
inline DWORD MP3Play::msec2bytes(DWORD msec)
{
	// obl̂PTvEɐ
	return (DWORD)((msec * (Frequency * Channel * 2 / 1000.0f)) + ((DWORD)(msec * (Frequency * Channel * 2 / 1000.0f)) % (DWORD)(Frequency * Channel * 2 / 1000.0f)));
}
