//
// MPEG1 Audio Layer-3 Class Header
// Copyright(C) 2000 by TOx2RO / O2 Software All rights reserved.
//
// MP3Play.h
//

#ifndef __MP3PLAY_H__
#define __MP3PLAY_H__

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <mmsystem.h>
#include <process.h>
#include ".\\include\\mp3dec.h"

const WORD MaxBufferingNumber = 64;				// őobt@Ot[(KWȏw)

// Đ
enum PlayState
{
	Closed,
	Opened,
	Playing,
	Paused
};

// G[R[h
enum Error
{
	NoError,									// G[Ȃ
	NoFile,										// t@CȂ
	NoMP3,										// loRł͂Ȃ
	NoMemory,									// [s
	UnknownError								// m̃G[
};

// 10-Bands Equalizer
struct EQ
{
	signed char _60;							// 60Hz
	signed char _170;							// 170Hz
	signed char _310;							// 310Hz
	signed char _600;							// 600Hz
	signed char _1k;							// 1kHz
	signed char _3k;							// 3kHz
	signed char _6k;							// 6kHz
	signed char _12k;							// 12kHz
	signed char _14k;							// 14kHz
	signed char _16k;							// 16kHz
};

class MP3Play {
public:
	MP3Play();									// RXgN^
	~MP3Play();									// fXgN^
	LRESULT	Open(LPSTR mp3file);				// loRt@CJ
	LRESULT Close();							// loRt@C
	LRESULT Play(DWORD start,DWORD end);		// Đ
	LRESULT LoopPlay(DWORD start,				// [vĐ
					 DWORD end,
					 DWORD loop,
					 DWORD number);
	LRESULT Pause();							// ꎞ~
	LRESULT Resume();							// ꎞ~
	LRESULT Stop();								// ~
	LRESULT Equalize(EQ eq);					// CRCU[

private:
	// waveOut R[obN֐
	static void CALLBACK waveOutProc(HWAVE hwo,UINT uMsg,DWORD dwInstance,DWORD dwParam1,DWORD dwParam2);
	// fR[hXbh
	static DWORD WINAPI DecodeFunc(LPVOID dwInstance); 
	// ~bt[ɕϊ
	inline DWORD msec2frame(DWORD msec);
	// t[~bɕϊ
	inline DWORD frame2msec(DWORD frame);
	// ~boCgɕϊ(PCM)
	inline DWORD msec2bytes(DWORD bytes);

private:
	PlayState State;							// Đ
	DWORD LoopCount;							// [vJE^
	DWORD Partition;							// ݍĐĂubN
	BYTE sw;									// _uobt@OpXCb`
	DWORD BufferingNumber;						// obt@Ot[

	HANDLE ThreadHandle;						// loRfR[hXbhnh
	DWORD ThreadID;								// loRfR[hXbhhc

	HANDLE FileHandle;							// loRt@Cnh
	HANDLE MapFile;								// loRt@C}bsOIuWFNg
	BYTE* pSrcFile;								// loRt@C̊JnAhX
	BYTE* pFrameData;							// f[^JnAhX(t@CJnAhX{wb_)
	DWORD NowPos;
	HWAVEOUT WaveOut;							// o̓foCX̃nh
	WAVEFORMATEX PCMwf;							// oblWAVEFORMAT\

	MPEG_DECODE_PARAM MP3DP[2];					// loRfR[h
	MPEG_DECODE_INFO MP3DI;

	WAVEHDR PCMwh[2];							// oblf[^obt@wb_[
	LPVOID Buffer[2];							// oblf[^obt@ւ̃|C^

	LPSTR FileName;								// loRt@Cl[
	DWORD FileSize;								// loRt@CTCY
	DWORD PartitionNumber;						// Đ̕(ĐTCYobt@TCY)
	DWORD startSec;								// ĐJnʒu(~b)
	DWORD endSec;								// ĐIʒu(~b)
	DWORD loopSec;								// [vJnʒu(~b)
	BYTE LoopMode;								// Đ[h(0:ʏĐ 1:[vĐ)
	bool NowLooping;							// ݃[v(true:[v false:[vł͂Ȃ)
	bool InfiniteLoop;							// [v(true:[v false:[vł͂Ȃ)

	WORD MpegSpec;								// lodf̃o[W
	WORD Bitrate;								// rbg[g
	WORD Frequency;								// TvO[g
	WORD Channel;								// `l
	WORD FrameSize;								// t[TCY
};
#endif